﻿{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     中国人自己的开放源码第三方开发包                         }
{                   (C)Copyright 2001-2008 CnPack 开发组                       }
{                   ------------------------------------                       }
{                                                                              }
{            本开发包是开源的自由软件，您可以遵照 CnPack 的发布协议来修        }
{        改和重新发布这一程序。                                                }
{                                                                              }
{            发布这一开发包的目的是希望它有用，但没有任何担保。甚至没有        }
{        适合特定目的而隐含的担保。更详细的情况请参阅 CnPack 发布协议。        }
{                                                                              }
{            您应该已经和开发包一起收到一份 CnPack 发布协议的副本。如果        }
{        还没有，可访问我们的网站：                                            }
{                                                                              }
{            网站地址：http://www.cnpack.org                                   }
{            电子邮件：master@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

Unit SSMainFrm;
{ |<PRE>
================================================================================
* 软件名称：文件夹智能同步工具
* 单元名称：主窗体单元
* 单元作者：周劲羽 (zjy@cnpack.org)
* 备    注：
* 开发平台：PWinXP SP3 + Delphi 7.1
* 兼容测试：
* 本 地 化：该单元中的字符串暂不符合本地化处理方式
* 单元标识：$Id: $
* 修改记录：2008.10.24 V1.0
*               创建单元
================================================================================
|</PRE>}

//渣渣皮于2024.03.22改为使用Delphi XE 12编译

Interface

Uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ShellCtrls, ExtCtrls, IniFiles, Buttons, CnCommon,
  IOUtils, FileCtrl;

Type
  TSSMainForm=Class(TForm)
    StatusBar: TStatusBar;
    pnl1: TPanel;
    lbl3: TLabel;
    ListView: TListView;
    btnAdd: TButton;
    btnDel: TButton;
    btnClear: TButton;
    btnUp: TButton;
    btnDown: TButton;
    btnImport: TButton;
    btnExport: TButton;
    btnExecute: TButton;
    pb1: TProgressBar;
    lbl4: TLabel;
    pnl2: TPanel;
    lbl1: TLabel;
    lbl2: TLabel;
    chkIncSub: TCheckBox;
    dlgOpen: TOpenDialog;
    dlgSave: TSaveDialog;
    tmr1: TTimer;
    btnAbout: TButton;
    btnExit: TButton;
    edtSrc: TEdit;
    edtDst: TEdit;
    btnText: TButton;
    btnSrcDir: TButton;
    btnDstDir: TButton;
    Procedure btnAddClick(Sender: TObject);
    Procedure btnDelClick(Sender: TObject);
    Procedure btnClearClick(Sender: TObject);
    Procedure btnUpClick(Sender: TObject);
    Procedure btnDownClick(Sender: TObject);
    Procedure btnImportClick(Sender: TObject);
    Procedure btnExportClick(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure MyFun;//多线程
    Procedure MyFunFree;//释放多线程
    Procedure btnExecuteClick(Sender: TObject);
    Procedure FormDestroy(Sender: TObject);
    Procedure tmr1Timer(Sender: TObject);
    Procedure btnExitClick(Sender: TObject);
    Procedure btnAboutClick(Sender: TObject);
    Procedure btnSrcDirClick(Sender: TObject);
    Procedure btnDstDirClick(Sender: TObject);
    Procedure btnTextClick(Sender: TObject);
  Private
    { Private declarations }
    FFileCnt: Integer;
    FExecuting: Boolean;
    FAbort: Boolean;
    FCurrMsg: String;
    FStartTick: Cardinal;
    FProcTick: Cardinal;
    FProcCnt: Integer;
    FCopyCnt: Integer;
    FDelCnt: Integer;
    FFileSize: Int64; //文件大小
    FSrcDir, FDstDir: String;
    Procedure SaveToFile(Const FileName: String);
    Procedure LoadFromFile(Const FileName: String);
    Procedure UpdateIndex;
    Procedure FileCntProc(Const FileName: String; Const Info: TSearchRec; Var Abort: Boolean);
    Procedure FileSyncProc(Const FileName: String; Const Info: TSearchRec; Var Abort: Boolean);
    Procedure FileDelProc(Const FileName: String; Const Info: TSearchRec; Var Abort: Boolean);
    Procedure DirDelProc(Const SubDir: String);
  Public
    { Public declarations }
  End;

Var
  SSMainForm: TSSMainForm;

Implementation

{$R *.dfm}

//判断是否为子文件夹 注:渣渣皮添加

Function IsSubdirectory(Const ParentDir, SubDir: String): Boolean;
Var
  SubDirs: TArray<String>;
  i: Integer;
Begin
  // 获取父文件夹中的所有子文件夹路径
  SubDirs:=TDirectory.GetDirectories(ParentDir);

  // 检查子文件夹是否在父文件夹的子文件夹列表中
  Result:=False;
  For i:=0 To High(SubDirs) Do
  Begin
    If SameText(SubDir, SubDirs[i]) Then
    Begin
      Result:=True;
      Break;
    End;
  End;
End;

Procedure TSSMainForm.FormCreate(Sender: TObject);
Begin
  Application.Title:=Caption;
  LoadFromFile(ChangeFileExt(Application.ExeName, '.ssb'));
End;

Procedure TSSMainForm.FormDestroy(Sender: TObject);
Begin
  If ListView.Items.Count=0 Then
  Begin
    DeleteFile(ChangeFileExt(Application.ExeName, '.ssb'));
  End
  Else
    SaveToFile(ChangeFileExt(Application.ExeName, '.ssb'));
End;

Procedure TSSMainForm.btnAddClick(Sender: TObject);
Var
  i: Integer;
Begin
  If Not DirectoryExists(edtSrc.Text) Then
    ErrorDlg('源文件夹不存在！')
  Else If Not DirectoryExists(edtDst.Text) Then
    ErrorDlg('目标文件夹不存在！')
  Else If SameText(Trim(edtSrc.Text), Trim(edtDst.Text)) Then
    ErrorDlg('源文件夹与目标文件夹不能相同！')
  Else If IsSubdirectory(edtSrc.Text, edtDst.Text) Then
    ErrorDlg('目标文件夹不能是源文件夹的子文件夹！')
  Else If IsSubdirectory(edtDst.Text, edtSrc.Text) Then
    ErrorDlg('源文件夹不能是目标文件夹的子文件夹！')
  Else
  Begin
    If ListView.Items.Count>0 Then
    Begin
      For i:=0 To ListView.Items.Count-1 Do
      Begin
        If edtSrc.Text+edtDst.Text=ListView.Items[i].SubItems[0]+ListView.Items[i].SubItems
          [1] Then
        Begin
          ErrorDlg('列表中已存在此源文件夹和目标文件夹,无需添加');
          Abort; //终止
        End;
      End;
    End;

    With ListView.Items.Add Do
    Begin
      Caption:=IntToStr(index+1);
      SubItems.Add(edtSrc.Text);
      SubItems.Add(edtDst.Text);
      If chkIncSub.Checked Then
        SubItems.Add('包含')
      Else
        SubItems.Add('不包含');
    End;
  End;
End;

Procedure TSSMainForm.btnDelClick(Sender: TObject);
Begin
  If ListView.Items.Count>0 Then
  Begin
    ListViewDeleteSelected(ListView);
    UpdateIndex;
  End;
End;

Procedure TSSMainForm.btnClearClick(Sender: TObject);
Begin
  If ListView.Items.Count>0 Then
  Begin
    If QueryDlg('确定要清空吗？') Then
    Begin
      ListView.Clear;
      lbl4.Caption:='已用 0:00:00 剩余 0:00:00';
      pb1.Position:=0;
      StatusBar.SimpleText:='';
    End;
  End;
End;

Procedure TSSMainForm.btnUpClick(Sender: TObject);
Begin
  If ListView.Items.Count>0 Then
  Begin
    ListViewMoveUpSelected(ListView);
    UpdateIndex;
  End;
End;

Procedure TSSMainForm.btnDownClick(Sender: TObject);
Begin
  If ListView.Items.Count>0 Then
  Begin
    ListViewMoveDownSelected(ListView);
    UpdateIndex;
  End;
End;

Procedure TSSMainForm.UpdateIndex;
Var
  i: Integer;
Begin
  For i:=0 To ListView.Items.Count-1 Do
    ListView.Items[i].Caption:=IntToStr(i+1);
End;

Procedure TSSMainForm.LoadFromFile(Const FileName: String);
Var
  i: Integer;
Begin
  ListView.Clear;
  With TMemIniFile.Create(FileName, TEncoding.UTF8) Do
  Try
    i:=1;
    While SectionExists(IntToStr(i)) Do
    Begin
      With ListView.Items.Add Do
      Begin
        Caption:=IntToStr(i);
        SubItems.Add(ReadString(IntToStr(i), 'SrcDir', ''));
        SubItems.Add(ReadString(IntToStr(i), 'DstDir', ''));
        If ReadString(IntToStr(i), 'IncSub', '')='包含' Then
          SubItems.Add('包含')
        Else
          SubItems.Add('不包含');
      End;
      Inc(i);
    End;
  Finally
    Free;
  End;
End;

Procedure TSSMainForm.SaveToFile(Const FileName: String);
Var
  i: Integer;
Begin
  DeleteFile(FileName);
  With TMemIniFile.Create(FileName, TEncoding.UTF8) Do
  Try
    For i:=0 To ListView.Items.Count-1 Do
    Begin
      WriteString(ListView.Items[i].Caption, 'SrcDir', ListView.Items[i].SubItems[0]);
      WriteString(ListView.Items[i].Caption, 'DstDir', ListView.Items[i].SubItems[1]);
      If ListView.Items[i].SubItems[2]='包含' Then
        WriteString(ListView.Items[i].Caption, 'IncSub', '包含')
      Else
        WriteString(ListView.Items[i].Caption, 'IncSub', '不包含');
    End;
  Finally
    UpdateFile;
    Free;
  End;
End;

Procedure TSSMainForm.btnImportClick(Sender: TObject);
Begin
  If dlgOpen.Execute Then
  Begin
    LoadFromFile(dlgOpen.FileName);
  End;
End;

Procedure TSSMainForm.btnExportClick(Sender: TObject);
Begin
  If (ListView.Items.Count>0) And dlgSave.Execute Then
  Begin
    SaveToFile(dlgSave.FileName);
  End;
End;

Function GetFolderSize(Const AFolder: String): Int64;
  //获取包含子文件夹的文件总大小 注:渣渣皮添加
Var
  SearchRec: TSearchRec;
  Path: String;
Begin
  Result:=0; //这个函数只计算文件的大小，不包括文件夹本身的大小

    //Result:=SearchRec.Size;//如果你需要计算文件夹本身的大小，可以在改为Result := SearchRec.Size;
  Path:=IncludeTrailingPathDelimiter(AFolder);

  If FindFirst(Path+'*.*', faAnyFile, SearchRec)=0 Then
  Begin
    Repeat
      If (SearchRec.Name<>'.') And (SearchRec.Name<>'..') Then
      Begin
        If (SearchRec.Attr And faDirectory)=faDirectory Then
          Result:=Result+GetFolderSize(Path+SearchRec.Name)
        Else
          Result:=Result+SearchRec.Size;
      End;
    Until FindNext(SearchRec)<>0;
    FindClose(SearchRec);
  End;
End;

Function GetDiskFree(Drive: String): Int64;//获取磁盘的剩余空间 注:渣渣皮添加
Var
  FreeBytes: Int64;
  TotalBytes: Int64;
Begin
  If GetDiskFreeSpaceEx(PChar(Drive), FreeBytes, TotalBytes, nil) Then
  Begin
    Result:=FreeBytes;
  End
  Else
  Begin
    Result:=0;
  End;
  //Result:=Result Shr 20;//以兆为单位
End;

Procedure TSSMainForm.MyFunFree;//释放多线程 注:渣渣皮添加
Begin
  TThread.CreateAnonymousThread(MyFun).Suspend; //挂起多线程
  TThread.CreateAnonymousThread(MyFun).Free; //释放多线程
  FExecuting:=False;
  tmr1.Enabled:=False;
  lbl4.Caption:='已用 0:00:00 剩余 0:00:00';
  pb1.Position:=0;
  StatusBar.SimpleText:='';
  btnExecute.Caption:='同步(&T)';
End;

Procedure TSSMainForm.MyFun;//多线程 注:渣渣皮添加
Var
  i: Integer;
  kj: Int64;
  pf: String;

  Procedure ControlSetEnabled(AEnabled: Boolean);
  Var
    i: Integer;
  Begin
    For i:=0 To ComponentCount-1 Do
      If (Components[i] Is TControl) And (Components[i].Tag=1) Then
        TControl(Components[i]).Enabled:=AEnabled;
  End;

Begin
  If FExecuting Then
  Begin
    FAbort:=QueryDlg('是否中断处理？');
  End
  Else
  Begin
    ControlSetEnabled(False);
    FExecuting:=True;
    FAbort:=False;
    pb1.Position:=0;
    btnExecute.Caption:='中断(&T)';
    Try
      pb1.Position:=0;
      FFileCnt:=0;
      FCopyCnt:=0;
      FDelCnt:=0;
      FProcCnt:=0;
      FStartTick:=GetTickCount;
      FProcTick:=0;
      FFileSize:=0;
      tmr1.Enabled:=True;
      For i:=0 To ListView.Items.Count-1 Do
      Begin
        FSrcDir:=MakePath(ListView.Items[i].SubItems[0]);
        FCurrMsg:='正在统计: '+FSrcDir;
        FindFile(FSrcDir, '*.*', FileCntProc, nil, ListView.Items[i].SubItems[2]='包含',
          True);
        If FAbort Then
        Begin
          MyFunFree; //释放多线程
          Exit;
        End;
      End;
      pb1.Max:=FFileCnt;

      FProcTick:=GetTickCount;
      For i:=0 To ListView.Items.Count-1 Do
      Begin
        FSrcDir:=MakePath(ListView.Items[i].SubItems[0]);
        FDstDir:=MakePath(ListView.Items[i].SubItems[1]);

        If Not DirectoryExists(FSrcDir) Then
        Begin
          FAbort:=True;
          MyFunFree; //释放多线程
          ErrorDlg('列表中第'+IntToStr(i+1)+'项的源文件夹不存在,无法同步');
          Exit;
        End;

        FCurrMsg:='正在处理: '+FSrcDir;
        //先删除不存在于源文件夹中的文件,再删除目标文件夹中和源文件夹中时间不一致的文件
        FindFile(FDstDir, '*.*', FileDelProc, DirDelProc, ListView.Items[i].SubItems[2]=
          '包含', True);

        pf:=Copy(FDstDir, 1, 1);
        If (GetFolderSize(FSrcDir)-FFileSize)>GetDiskFree(pf+':') Then
        Begin
          FAbort:=True;
          MyFunFree; //释放多线程
          kj:=(GetFolderSize(FSrcDir)-FFileSize-GetDiskFree(pf+':'));
          ErrorDlg('列表中第'+IntToStr(i+1)+'项的目标文件夹所在的'+Copy(FDstDir, 1, 1)+
            '盘剩余空间不足,无法复制'#13#10+pf+'盘还需要有'+IntToStr(kj Div 1024 Div 1024 Div 1024)+
            ' GB的剩余空间'#13#10+pf+'盘还需要有'+IntToStr(kj Div 1024 Div 1024)+
            ' MB的剩余空间'#13#10+pf+'盘还需要有'+IntToStr(kj Div 1024)+' KB的剩余空间'#13#10+pf+
            '盘还需要有'+IntToStr(kj)+' Byte的剩余空间');
          Exit;
        End;

        //最后再复制源文件夹中的新文件
        FindFile(FSrcDir, '*.*', FileSyncProc, nil, ListView.Items[i].SubItems[2]='包含',
          True);
        If FAbort Then
        Begin
          MyFunFree; //释放多线程
          Exit;
        End;
      End;
      tmr1Timer(nil);
    Finally
      tmr1.Enabled:=False;
      ControlSetEnabled(True);
      FExecuting:=False;
      btnExecute.Caption:='同步(&T)';
      If Not FAbort Then
      Begin
        InfoDlg(Format('文件夹同步完成，共更新文件 %d 个，删除旧文件(夹) %d 个！', [FCopyCnt, FDelCnt]));
        lbl4.Caption:='已用 0:00:00 剩余 0:00:00';
        pb1.Position:=0;
        StatusBar.SimpleText:='';
      End;
    End;
  End;
End;

Procedure TSSMainForm.btnExecuteClick(Sender: TObject);
Begin
  If ListView.Items.Count>0 Then
  Begin
    TThread.CreateAnonymousThread(MyFun).Start;
      //开始多线程 //注意myfun必须是方法，不能是函数
  End;
End;

Procedure TSSMainForm.btnAboutClick(Sender: TObject);
Begin
  InfoDlg(Caption+#13#10#13#10+
    '该软件用于同步多个文件夹中的文件。同步后的目标文件夹'#13#10+
    '将与源文件夹内容完全一致。同步更新时自动复制源文件'#13#10+
    '夹中大小或日期变更过的文件，并删除目标文件夹中不存'#13#10+'在于源文件夹的文件和文件夹。'#13#10#13#10+
    '软件作者 周劲羽 (zjy@cnpack.org)'#13#10+'版权所有 (C)2001-2008 CnPack 开发组'#13#10+
    '2024.03.22渣渣皮基于1.0版更新');
End;

Procedure TSSMainForm.btnExitClick(Sender: TObject);
Begin
  If QueryDlg('确定要退出吗？') Then
    Close;
End;

Procedure TSSMainForm.tmr1Timer(Sender: TObject);
Var
  t1, t2: TDateTime;
Begin
  pb1.Position:=FProcCnt;
  StatusBar.SimpleText:=FCurrMsg;
  t1:=(GetTickCount-FStartTick)/1000/3600/24;
  If (FProcTick<>0) And (FProcCnt>0) Then
    t2:=((GetTickCount-FProcTick)/1000/3600/24)*(1-FFileCnt/FProcCnt)
  Else
    t2:=0;
  lbl4.Caption:=Format('已用 %s 剩余 %s', [TimeToStr(t1), TimeToStr(t2)]);
End;

Procedure TSSMainForm.btnSrcDirClick(Sender: TObject);
Var
  vPath: TArray<String>;
Begin
  //TPath.GetTempPath
  //dHidePinnedPlaces  导航窗格的默认视图中隐藏项目。
  //sdForceShowHidden  显示隐藏的文件夹。
  //sdAllowMultiselect 允许你在“选择文件夹”对话框中选择多个项目
  If SelectDirectory(edtSrc.Text, vPath, [{sdHidePinnedPlaces, sdForceShowHidden, sdAllowMultiselect}],
    '请选择源文件夹', '源文件夹', '确定') Then
  Begin
    edtSrc.Text:=vPath[0];
  End;
End;

Procedure TSSMainForm.btnTextClick(Sender: TObject);
Begin
  InfoDlg('2024.03.22渣渣皮基于1.0版更新'#13#10+'以下为此2.0版更新说明:'+#13#10#13#10+
    '1.程序自动以管理员身份运行'#13#10+'2.修正在界面上按ALT键导致界面按钮显示出错的问题'#13#10+
    '3.修正判断是否为子文件夹出错的问题'#13#10+
    '4.修改同步按钮的快捷键为Alt+T,因为导入按钮和同步按钮的快捷键是同一个'#13#10+
    '5.增加[列表中已存在此源文件夹和目标文件夹,无需添加]的文字提示'#13#10+
    '6.增加同步完成后自动清空底部的进度条和文字提示'#13#10+'7.点击同步按钮时,判断列表不为空才执行同步'#13#10+
    '8.点击退出时,弹出询问提示框'#13#10+'9.配置文件ssb字符编码改为UTF8'#13#10+
    '10.选择文件夹的对话框改为调用微软系统的对话框'#13#10+
    '11.点击同步时先删除不一致的文件,再检查目标磁盘剩余空间是否足够'#13#10+
    '12.改为使用多线程同步文件,避免复制大文件时程序有时会假死的问题');
End;

Procedure TSSMainForm.btnDstDirClick(Sender: TObject);
Var
  vPath: TArray<String>;
Begin
  //TPath.GetTempPath
  //dHidePinnedPlaces  导航窗格的默认视图中隐藏项目。
  //sdForceShowHidden  显示隐藏的文件夹。
  //sdAllowMultiselect 允许你在“选择文件夹”对话框中选择多个项目
  If SelectDirectory(edtDst.Text, vPath, [{sdHidePinnedPlaces, sdForceShowHidden, sdAllowMultiselect}],
    '请选择目标文件夹', '目标文件夹', '确定') Then
  Begin
    edtDst.Text:=vPath[0];
  End;
End;

Procedure TSSMainForm.FileCntProc(Const FileName: String; Const Info: TSearchRec; Var Abort: Boolean);
Begin
  Inc(FFileCnt);
  Abort:=FAbort;
End;

Procedure TSSMainForm.FileSyncProc(Const FileName: String; Const Info: TSearchRec; Var Abort: Boolean);
Var
  DstName: String;
Begin
  If FAbort Then
  Begin
    Abort:=True;
    MyFunFree; //释放多线程
    Exit;
  End;

  DstName:=FDstDir+Copy(FileName, Length(FSrcDir)+1, MaxInt);
  If Not FileExists(DstName) Then
  Begin
    ForceDirectories(ExtractFileDir(DstName));
    FCurrMsg:='正在复制: '+FileName;
    StatusBar.SimpleText:=FCurrMsg;
    CopyFile(PChar(FileName), PChar(DstName), False);
    Inc(FCopyCnt);
  End;
  Inc(FProcCnt);
End;

Procedure TSSMainForm.DirDelProc(Const SubDir: String);
Begin
  If Not DirectoryExists(FSrcDir+SubDir) Then
  Begin
    FCurrMsg:='正在删除: '+FDstDir+SubDir;
    Deltree(FDstDir+SubDir);
    Inc(FDelCnt);
  End;
End;

Procedure TSSMainForm.FileDelProc(Const FileName: String; Const Info: TSearchRec; Var Abort: Boolean);
Var
  SrcName: String;
Begin
  If FAbort Then
  Begin
    Abort:=True;
    MyFunFree; //释放多线程
    Exit;
  End;

  SrcName:=FSrcDir+Copy(FileName, Length(FDstDir)+1, MaxInt);
  If Not FileExists(SrcName) Then//删除不存在于源文件夹中的文件
  Begin
    FCurrMsg:='正在删除: '+FileName;
    SetFileAttributes(PChar(FileName), FILE_ATTRIBUTE_NORMAL);
    DeleteFile(FileName);
    Inc(FDelCnt);
  End
  Else
  Begin
    //删除目标文件夹中和源文件夹中时间不一致的文件
    If GetFileDateTime(FileName)<>GetFileDateTime(SrcName) Then
    Begin
      FFileSize:=FFileSize+GetFileSize(SrcName); //获取源文件的大小
      FCurrMsg:='正在删除: '+FileName;
      SetFileAttributes(PChar(FileName), FILE_ATTRIBUTE_NORMAL);
      DeleteFile(FileName);
    End;
  End;
End;

End.

